      ! Fixed a problem which causes discontinued Tbkgrd.   Ye   1/21/98
      ! 09/04               -  Replaced NBUFF and NCORE with MAX_SCANS      


      !  Routine calculates background Tb

      subroutine bkgrd_fill(nwork, Tc, sfctype, pixel_status,
     &            rain_status, T_bkgrd)

      implicit none
      include 'parameters.inc'

      integer     nwork
      real        Tc(NPIX, MAX_SCANS, NCHAN)
      integer*1   sfctype(NPIX, MAX_SCANS)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      real        T_bkgrd(NPIX, MAX_SCANS, NCHAN)

      real        tb_default(NCHAN)
      real        sum_Tb(NCHAN)

      integer     n_clear, lin, pix, nch, i, j

      ! Default backgrounds (used until clear pixel is found)
      tb_default(1) = 178.
      tb_default(2) = 228.
      tb_default(3) = 260.
      tb_default(4) = 180.
      tb_default(5) = 230.
      tb_default(6) = 274.
      tb_default(7) = 282.

 
      do lin = 1, nwork
         do pix = 1, NPIX

c           if (pixel_status(pix,lin) .lt. 0) goto 10

            ! Background for clear pixels is just the Tb
            if ( rain_status(pix,lin) .lt. 0) then
              do nch = 1, NCHAN
                T_bkgrd(pix,lin,nch) = Tc(pix,lin,nch)
              end do

            else
               ! Proceed with potentially raining pixels
               n_clear = 0
               do nch = 1, NCHAN
                  sum_Tb(nch) = 0.
               end do

               do i = lin-1, lin+1
                  do j = pix-1, pix+1

                     if(i .ge. 1 .and. i .le. nwork .and.
     &                  j .ge. 1 .and. j .le. NPIX) then

                        if (sfctype(j,i) .eq. sfctype(pix,lin)  .and.
     &                  pixel_status(j, i) .ge. 0) then

                            if(i .lt. lin .or.
     &                        (i .eq. lin .and. j .lt. pix)) then

                               n_clear = n_clear + 1
                               do nch = 1, NCHAN
                                  sum_Tb(nch)=sum_Tb(nch) +
     &                                               T_bkgrd(j,i,nch)
                               end do

                            elseif(((i .gt. lin) .or.
     &                              (i .eq. lin .and. j .gt. pix)) .and.
     &                               rain_status(j,i) .lt. 0) then

                               n_clear = n_clear + 1
                               do nch = 1, NCHAN
                                  sum_Tb(nch) = sum_Tb(nch) +
     &                                                 Tc(j,i,nch)
                               end do
                            endif
                        endif
                     endif

                  end do   ! end j
               end do   ! end i

               if ( n_clear .gt. 0 ) then
                  do nch = 1, NCHAN
                     T_bkgrd(pix,lin,nch) = sum_Tb(nch)/float(n_clear)
                     tb_default(nch) = T_bkgrd(pix,lin,nch)
                  end do
               else
                  do nch = 1, NCHAN
                     T_bkgrd(pix,lin,nch) = Tb_default(nch)
                  end do
               endif
            endif  !end else
 10      end do
      end do

      return
      end
