      ! Example code to assign freezing heights based upon climate
      ! sst values.

      ! Ye Hong 10/30/1997   Added 500m to FL as follows (according to CK):
      ! frzheight(pix,lin) = (sst - 273.15)/0.0065 ===>
      ! frzheight(pix,lin) = 500. + (sst - 273.15)/0.0065
      ! 09/04   Replaced NBUFF and NCORE with MAX_SCANS

      subroutine frzhgt_climate(nwork, lat, lon, stdtime, sstdata, 
     &                 pixel_status, frzheight)

      implicit none
      include 'parameters.inc'

      integer     nwork
      real        lat(NPIX, MAX_SCANS)
      real        lon(NPIX, MAX_SCANS)
      integer*2   stdtime(MAX_SCANS, 6)
      integer*2   sstdata(0:143,0:90,12)
      integer*2   pixel_status(NPIX, MAX_SCANS)
      real        frzheight(NPIX, MAX_SCANS)      ! km

      integer     lin, pix
      integer     month, row, col
      real        sst

      do lin = 1, nwork
         do pix = 1, NPIX

            ! Skip if pixel is not O.K.           
            if ( pixel_status(pix,lin) .lt. 0) goto 999
c
            month = stdtime(lin,2)
            row = int((lon(pix,lin) + 180.0)/2.5 )
            col = int((lat(pix,lin) + 90.0)/2.0)
            if(row .gt. 143)then
               row = 143
            else if(row .lt. 0)then
               row = 0
            endif
            if(col .gt. 90)then
               col = 90
            else if(col .lt. 0)then
               col = 0
            endif
            sst = 0.1*sstdata(row, col, month)
            frzheight(pix,lin) = 500. + (sst - 273.15)/0.0065
  999    end do
      end do

      return
      end

