      ! Routine to replace coastal pixels with rain rates less than 2 mm/hr
      ! with 0 mm/hr when none of the 9 pixels centered on the pixel in question       ! have rain rates greater than 2 mm/hr.

      subroutine rain_ctrl(nwork, pixel_status, rain_status,
     &            sfctype, sfcrain, convect)


      implicit none           ! Remove at own risk!

C ---------- Variable Declarations ----------

      include 'parameters.inc'

      integer     nwork
      integer*2   pixel_status(NPIX, MAX_SCANS)
      integer*2   rain_status(NPIX, MAX_SCANS)
      integer*1   sfctype(NPIX, MAX_SCANS)
      real        sfcrain(NPIX, MAX_SCANS)
      real        convect(NPIX, MAX_SCANS)

      real        temp_sfcrain(NPIX, MAX_SCANS)
      real        temp_convect(NPIX, MAX_SCANS)

      integer     lin, pix
      integer     ip, jp
      integer     ncount

      do lin = 1, nwork
         do pix = 1, NPIX
 
            temp_sfcrain(pix,lin) = sfcrain(pix,lin)
            temp_convect(pix,lin) = convect(pix,lin)
         end do
      end do

      ! Replace coast pixels which do not have a neighbor greater than 2 mm/hr

      do lin = 1, nwork
         do pix = 1, NPIX
           ncount=0
            if (sfctype(pix,lin) .ne. 2) goto 10
            if ((temp_sfcrain(pix,lin) .gt. 0.0).and.
     &          (pixel_status(pix,lin) .ge. 0)) then
              do ip = lin-1, lin+1
                 do jp = pix-1, pix+1
                    IF((jp.ge.1).and.(jp.le.NPIX).and.
     &                 (ip.ge.1).and.(ip.le.nwork)) THEN
                      IF(temp_sfcrain(pix,lin) .gt. 2.0) THEN
                        ncount=ncount+1
                      ENDIF
                    ENDIF
                 end do
              end do
              if(ncount .eq. 0) then
                sfcrain(pix,lin) = 0.0
                convect(pix,lin) = 0.0
              endif
            endif
10       end do
      end do
c
      return
      end

